#pragma once

#include "V3.h"
#include "framebuffer.h"

class SuperPixel;
class SamplingLocation;

class IFB {
public:
	SuperPixel *spix;
	int w, h;
	IFB(int _w, int _h);
	void AddSamplingLocation(V3 pP, int u0, int v0);
	void Visualize(FrameBuffer *visfb, V3 c0, V3 c1, int minsls = -1, int maxsls = -1);
    int Min();
	int Max();
	SuperPixel* Get(int u, int v);
	void AddSamplingLocations(PPC *ifbppc, FrameBuffer *fb, PPC *ppc);
	void Clear();
};

class SuperPixel {
public:
	SamplingLocation *sls;
	int slsN;
	int slsAN;
	SuperPixel();
	void AddSamplingLocation(V3 pP, int u0, int v0);
};

class SamplingLocation {
public:
	V3 uv1; // used to be (u.5, v.5, 1.0f)
	float z; // z of output image reprojected sample
	int u0, v0; // coordinates of output image pixel that generated this sampling location
	SamplingLocation(V3 pP, int u0, int v0);
	SamplingLocation() {};
};

